#!/usr/bin/env python
#-*- coding: utf-8 -*-

import numpy as np
import matplotlib.pyplot as plt

from pylab import *        
        
      
def animationTrajectoire(times,list_traj):
    ite = 0
    
    theta = np.arange(0.0,2*np.pi,0.01)
    rb = 0.1
    xb = rb * np.cos(theta)
    yb = rb * np.sin(theta)
    sq = np.array([-2,-2])
    
    plt.ion()
    plt.hold('on')
    dt = times[1]-times[0]
    T = times[-1]
    k = int(0.10*T*0.1/dt)  # min(T*0.25,2*np.pi)
    if (k==0):
        k=1
    for ite,t in enumerate(times):
        if (ite % k == 0):
            plt.clf()
            plt.axis('equal')    
            for tr in list_traj:
                plt.plot(tr[ite][0]+xb,tr[ite][1]+yb)
                plt.plot([pos[0] for pos in tr],[pos[1] for pos in tr])
                
            plt.plot(xb,yb,"black")
            plt.plot(-2,2)
            plt.plot(2,-2)
            plt.axis('equal')
            plt.show()
            plt.pause(1e-15)
            #ite = ite+k
    
    plt.ioff()
    plt.hold('off')  
        
    for tr in list_traj:
        plt.plot([pos[0] for pos in tr],[pos[1] for pos in tr])
        
    plt.plot(xb,yb,"black")
    plt.plot(-2,2)
    plt.plot(2,-2)
    plt.axis('equal')
    plt.show()
    
    
        
def afficher(list_x,list_y):
    plt.hold('on')
    for j,absic in enumerate(list_x):
        plt.plot(absic,list_y[j], '-x',linewidth=4.0)
    
    plt.legend(["log10(err) vs log10(dt)"])
    plt.show()
    plt.hold('off')