#!/usr/bin/env python
#-*- coding: utf-8 -*-

import numpy as np
import copy


##----------------------------------
#  Methode de Euler explicite (exemple donné pour aider) :
def Euler(dt,Times,y0,Mp):
    sol = [y0];
    p0 = y0*1
    p1 = y0*0
    for t in Times:
        p1 = p0 + dt*f(t,p0,Mp)
        sol.append(p1)
        p0 = p1*1.0
    sol.pop()
    return sol
##----------------------------------         
    
    
##----------------------------------
#  Theta-schéma explicite :
def thetaSch(dt,Times,y0,Mp):
    sol = [y0];
    p0 = y0*1
    p1 = y0*0
    # Completer ICI : (donner la valeur optimale de theta)
    theta = 0.
    for t in Times:
        if (theta == 0.):
            # Completer ICI :
            #p1 = ...
        if (theta >0):    
            # Completer ICI :
            pt1 = Newton(dt,theta,t,p0,Mp)
            #p1 = ...
        
        sol.append(p1)
        p0 = p1*1.0
    sol.pop()
    return sol
##----------------------------------            
    
    
##----------------------------------
#  Methode de Nystrom :
def Nystrom(dt,Times,y0,Mp):
    sol = [y0];
    
    # Initialisation :
    soltmp = thetaSch(dt,np.array([0,dt]),y0,Mp)
    p0 = y0*1
    p1 = soltmp[1]
    p2 = y0*0
    for t in Times:
        # Completer ICI :
        #p2 = ...
                
        sol.append(p1)
        p0 = p1*1.0
        p1 = p2*1.0
    sol.pop()
    return sol
##----------------------------------    

##----------------------------------
# Algorithme de Newton applique à F(p) = p - theta*dt*f(t+theta*dt,p) - p0:
def Newton(dt,theta,t,p0,Mp):
    iteMax = 100
    p = p0*1
    err = p - theta*dt*f(t+theta*dt,p,Mp) - p0
    tol = 1e-5
    ite = 0
    # Matrice Identité :
    Id = np.eye(np.size(p0),np.size(p0))
    while((ite < iteMax) and (np.dot(err,err) > tol*tol)):
        # Completer ICI :
        #err = ...
        # Jacobienne JF :
        #JF = ...
        # Resolution du systeme lineaire JF s = err :
        s = np.linalg.solve(JF,err)
        # On deduit l'itere suivant dans la méthode de Newton :
        #p = ...
        
        
        ite = ite+1
        
    return p
##---------------------------------- 


##----------------------------------
#  fonction f problem Np corps :
def f(t,p,Mp):
    res = p*1.0;
    if (np.size(Mp) == 1):
        dist = np.sqrt(p[0]*p[0]+p[1]*p[1])
        # Completer ICI :
        #res[0] = ...
        #res[1] = ...
        #res[2] = ...
        #res[3] = ...
        

    if (np.size(Mp) >= 2):
        for i,mi in enumerate(Mp):
            sl = i*4
            res[sl] = p[sl+2]
            res[sl+1] = p[sl+3]
            dist0i = np.sqrt(p[sl]*p[sl]+p[sl+1]*p[sl+1])
            res[sl+2] = -p[sl] / (dist0i*dist0i*dist0i)
            res[sl+3] = -p[sl+1] / (dist0i*dist0i*dist0i)
            for j,mj in enumerate(Mp):
                sc = j*4
                if (j != i):
                    distij = np.sqrt((p[sl]-p[sc])*(p[sl]-p[sc])+(p[sl+1]-p[sc+1])*(p[sl+1]-p[sc+1]))
                    res[sl+2] = res[sl+2] -mj*(p[sl]-p[sc]) / (distij*distij*distij)
                    res[sl+3] = res[sl+3] -mj*(p[sl+1]-p[sc+1]) / (distij*distij*distij)
            
    return res
##----------------------------------



##----------------------------------
#  fonction Jacobienne de f :
def Jf(t,p,Mp):
    resM = np.eye(np.size(p),np.size(p))*0
    
    for i,mi in enumerate(Mp):
        sl = i*4
        resM[sl,sl+2] = 1
        resM[sl+1,sl+3] = 1
        dist0i = np.sqrt(p[sl]*p[sl]+p[sl+1]*p[sl+1])
        
        resM[sl+2,sl] = -1.0 / (dist0i*dist0i*dist0i) + 3.0*p[sl]*p[sl] / (dist0i*dist0i*dist0i*dist0i*dist0i)
        resM[sl+2,sl+1] = 3.0*p[sl]*p[sl+1] / (dist0i*dist0i*dist0i*dist0i*dist0i) 
        resM[sl+3,sl+1] = -1.0 / (dist0i*dist0i*dist0i) + 3.0*p[sl+1]*p[sl+1] / (dist0i*dist0i*dist0i*dist0i*dist0i)
        resM[sl+3,sl] = 3.0*p[sl+1]*p[sl] / (dist0i*dist0i*dist0i*dist0i*dist0i)
        for j,mj in enumerate(Mp):
            sc = j*4
            if (j != i):
                distij = np.sqrt((p[sl]-p[sc])*(p[sl]-p[sc])+(p[sl+1]-p[sc+1])*(p[sl+1]-p[sc+1]))
                
                resM[sl+2,sl] = resM[sl+2,sl] - mj*( (1.0) / (distij*distij*distij) - 3.0*(p[sl]-p[sc])*(p[sl]-p[sc]) / (distij*distij*distij*distij*distij) )
                resM[sl+2,sc] = resM[sl+2,sc] - mj*( (-1.0) / (distij*distij*distij) + 3.0*(p[sl]-p[sc])*(p[sl]-p[sc]) / (distij*distij*distij*distij*distij) )
                
                resM[sl+2,sl+1] = resM[sl+2,sl+1] - mj*( - 3.0*(p[sl]-p[sc])*(p[sl+1]-p[sc+1]) / (distij*distij*distij*distij*distij) )
                resM[sl+2,sc+1] = resM[sl+2,sc+1] - mj*( 3.0*(p[sl]-p[sc])*(p[sl+1]-p[sc+1]) / (distij*distij*distij*distij*distij) )
                
                
                resM[sl+3,sl+1] = resM[sl+3,sl+1] - mj*( (1.0) / (distij*distij*distij) - 3.0*(p[sl+1]-p[sc+1])*(p[sl+1]-p[sc+1]) / (distij*distij*distij*distij*distij) )
                resM[sl+3,sc+1] = resM[sl+3,sc+1] - mj*( (-1.0) / (distij*distij*distij) + 3.0*(p[sl+1]-p[sc+1])*(p[sl+1]-p[sc+1]) / (distij*distij*distij*distij*distij) )
                
                resM[sl+3,sl] = resM[sl+3,sl] -mj*( - 3.0*(p[sl]-p[sc])*(p[sl+1]-p[sc+1]) / (distij*distij*distij*distij*distij) )
                resM[sl+3,sc] = resM[sl+3,sc] -mj*( 3.0*(p[sl]-p[sc])*(p[sl+1]-p[sc+1]) / (distij*distij*distij*distij*distij) )
            
    return resM
            
            
##----------------------------------


##----------------------------------
#  Methode de Runge-Kutta 4 (bonus) :
def RK4(dt,Times,y0,Mp):
    sol = [y0];
    p0 = y0*1
    p1 = y0*0
    for t in Times:
        # Completer ICI :
        #...
        
        sol.append(p1)
        p0 = p1*1.0
    sol.pop()
    return sol
##----------------------------------   