#!/usr/bin/env python
#-*- coding: utf-8 -*-

import numpy as np
import affichage

import algo



"""
    Calcul de la trajectoire d'un objet soumis à l'attraction gravitationnelle 
"""

##----------------------------------
# But du programme :
# 1. Visualiser la trajectoire d'une planete.
# 2. Analyse convergence de la methode.
butPrgm = 1
print "Que souhaitez vous faire ?"
print " 1. Visualiser la trajectoire d'une planète."
print " 2. Visualiser la trajectoire de deux planètes."
print " 3. Faire l'analyse de convergence."
butPrgm = input("Entrer le choix : ")

print ""
# Choix de la methode :
print "Choisir la methode :"
print " 1. Theta-Schema"
print " 2. Nystrom"
choixMeth = input("Entrer votre choix : ")
##----------------------------------


##----------------------------------
# Paramètres 

# Temps simulation
T = 4*np.pi

# Discretisation
dt = 0.1
N = T/dt + 1

Times = np.arange(0.0,T,dt)
##----------------------------------


##----------------------------------
# Partie I :
if (butPrgm==1):
    
    Np = 1
    ##----------------------------------
    # Etat initial :
    p0 = np.array([1.0,0.4,0.0,1.2])   
    # Masse planete :
    Mp = np.array([1.0]) 
    ##----------------------------------
        
    ##----------------------------------
    # Calcul solution approchée :
    if (choixMeth == 1):
        SOL = algo.thetaSch(dt,Times,p0,Mp)
        
    if (choixMeth == 2):
        SOL = algo.Nystrom(dt,Times,p0,Mp)
    ##----------------------------------

    ##----------------------------------
    # Affichage solution :
    affichage.animationTrajectoire(Times,[SOL]) 
    ##----------------------------------
 ##----------------------------------
    
    
    
    
##----------------------------------
# Partie II :    
if (butPrgm==2) :
    ##----------------------------------
    # Etat initial :
    p0 = np.array([1.0,0.0,0.0,1.0,-2.2,0.5,0.1,0.7])
    # Masses des deux planètes :
    Mp = np.array([1.0, 0.5])
    ##----------------------------------
    
    ##----------------------------------
    # Calcul solution approchée :
    if (choixMeth == 1):
        SOL = algo.thetaSch(dt,Times,p0,Mp)
    
    if (choixMeth == 2):
        SOL = algo.Nystrom(dt,Times,p0,Mp)
    ##----------------------------------

    list_tr = []
    for ite,m in enumerate(Mp):
        list_tr.append([np.array([x[ite*4], x[ite*4+1], x[ite*4+2], x[ite*4+3]]) for x in SOL])
    
    affichage.animationTrajectoire(Times,list_tr)    
##----------------------------------




    
##----------------------------------
# Partie III :    
print ""
if (butPrgm == 3):
    Np = 1
    ##----------------------------------
    # Choix vecteur initial pour obtenir la solution analytique :
    # Completer ICI (modifier les valeurs de p0 pour avoir la trajectoire exacte) :
    p0 = np.array([1.0,0.4,0.0,1.2])
    Mp = np.array([1.0])
    ##----------------------------------
    
    ##----------------------------------
    # Initialisation :
    SOL = []
    SOL_e = []
    T = np.pi
    list_dt = [0.5,0.1,0.05,0.01,0.005,0.001,0.0005,0.0001]
    list_err = [];
    ##----------------------------------
    
    ##----------------------------------
    # Iteration sur les pas dt :
    print "Calcul err vs dt :"
    for dt in list_dt:
        Times = np.arange(0.0,T,dt)
        N = T/dt + 1
        ##----------------------------------
        # Calcul solution exacte :
        # Completer ICI :
        #xexact = ...
        #yexact = ...
        #vxexact = ...
        #vyexact = ...
        
        SOL_e = [np.array([xexact[i], yexact[i], vxexact[i], vyexact[i]]) for i,t in enumerate(Times)]
        ##----------------------------------
        
        ##----------------------------------
        # Calcul solution approchée :
        if (choixMeth == 1):
            SOL = algo.thetaSch(dt,Times,p0,Mp)   
        
        if (choixMeth == 2):
            SOL = algo.Nystrom(dt,Times,p0,Mp)
        
        ##----------------------------------
        
        ##----------------------------------
        # Analyse erreur :
        maxerr = max([np.sqrt(np.dot(e-SOL_e[i], e-SOL_e[i])) for i,e in enumerate(SOL)])
        print "dt = ",dt," et err =",maxerr
        list_err.append(maxerr) 
        ##----------------------------------
    
    ##----------------------------------
    # Affichage solution :
    affichage.afficher([np.log10(list_dt)*(-1)], [np.log10(list_err)])
    ##----------------------------------
##----------------------------------


print "FIN \n"
########################################